package server

import (
	"game/common/proto/pb"
	"github.com/fox/fox/log"
)

func (s *ClientService) login() {
	log.DebugF("user:%v ready login", s.username)
	s.SendMsg(pb.ServiceTypeId_STI_Login, int32(pb.MsgId_ReqUserLoginId), &pb.ReqUserLogin{
		Username: s.username,
		Password: s.password,
		Ip:       "",
		DeviceId: "",
		Version:  "20250604123030",
	})
}

// 收到登陆成功消息，判断是否顶号
func (s *ClientService) onLogin(cMsg *pb.ClientMsg, msg *pb.RspUserLogin) {
	if msg.Code != pb.ErrCode_OK {
		log.ErrorF("login error:%v :%v", msg.Code, msg.Code.String())
		return
	}
	_ = cMsg
	s.userId = msg.UserId
	s.client.SetUid(msg.UserId)
	log.DebugF("user:%v id:%v login success", s.username, msg.UserId)
}
