package model

import (
	"game/common/constant"
	"game/common/utils"
	"game/server/login/config"
	"github.com/fox/fox/db"
	"github.com/fox/fox/log"
	"github.com/go-redis/redis/v8"
)

var (
	UserBindServiceRedis *redis.Client
	// UserDB    *gorm.DB
	// LogDB     *gorm.DB
)

func InitRedis() {
	log.Debug("init redis")
	var err error
	cfg := &config.Cfg.Redis
	UserBindServiceRedis, err = db.InitRedis(cfg.Password, cfg.Host, cfg.Port, constant.Redis3UserBindService)
	if err != nil {
		log.Fatal(err.Error())
		return
	}
	utils.AutoSetRedisPool(UserBindServiceRedis)
}

//
// func InitDb() {
//	log.Debug("init db")
//	var err error
//	cfg := &config.Cfg.Mysql
//	UserDB, err = db.InitMysql(cfg.Username, cfg.Password, cfg.Host, cfg.Port, cfg.DbName)
//	if err != nil {
//		log.Fatal(err.Error())
//		return
//	}
//	cfg = &config.Cfg.MysqlLog
//	LogDB, err = db.InitMysql(cfg.Username, cfg.Password, cfg.Host, cfg.Port, cfg.DbName)
//	if err != nil {
//		log.Fatal(err.Error())
//		return
//	}
//	// 自动迁移game库表结构
//	err = UserDB.AutoMigrate(
//		&UserAccount{},
//	)
//	if err != nil {
//		log.Fatal(err.Error())
//		return
//	}
//	// 自动迁移game_log库表结构
//	err = LogDB.AutoMigrate(
//		&UserLoginLog{},
//	)
//	if err != nil {
//		log.Fatal(err.Error())
//		return
//	}
// }
